Subject: Re: [netatalk-admins] NFS/SMB/Appleshare on the same file system

From: "Michael Rothwell" <[email-masked]>
Date: Sun, 13 Jul 1997 17:24:25 -0400

Thank you for the information. I'll add VETO to my smb.conf on Monday. Why
is the Netatalk team "recticent", I wonder?

----------
> From: Julian Elischer <[email-masked]>
> To: Michael Rothwell <[email-masked]>
> Cc: Kamal Kantawala <[email-masked]>; [email-masked];
[email-masked]
> Subject: Re: [netatalk-admins] NFS/SMB/Appleshare on the same file system
> Date: Sunday, July 13, 1997 4:18 PM
> 
> 
> 
> At whistle communitcations we sell a device that incorporated both
> netatalk and samba. I integrated netatalk into FreeBSD for this and 
> the present maintainer of SAMBA is on our staff. He is also in charge
> of netatalk issues here so you might say that the present maintainer of
> SAMBA has daily contact with netatlk. If you look at the
> newer releases of SAMBA you will see a feature called "veto file"
> What this does is dissallow SAMBA from reporting any hint of a ny
> pathname that contains tha names given in that command, to tha SAMBA
> users.
> 
> our VETO list includes .AppleDouble and other netatlkd related
> files. that SAMBA users can never delete their .AppleDouble
> directoies because they cannot see them.
> The newest patch release of SAMBA (being worked on now) Has
> a  NEW version of the veto facility. (I forget it's name)
> that has SLIGHTLY differnt semantics. An added feature of the new
> code is that if a SAMBA user has an EMPTY directory (as far as they are
> concerned, which actually contains a veto'd file that they cannot see.
> then a request to delete that directory WILL succeeed, as samba will
first
> remove the .AppleDouble file, reasoning that there is no longer any
reason
> for it as the parent directory has no other  entries.
> 
> So there is some interaction between SAMBA and NETATALK
> already (sponsored by Whsitle communications ( plug plug
www.whistle.com))
>  We are presently integrating internaltionalisation patches to enable
> samba and netatalk to present filenames in other character sets in 
> a unified and consistent manner.
> thes pathces will be given back as sson as they seem to work..
> (The SAMBA patches ARE back by definition as they are being
> done by jeremy, the Samba guy..)
> 
> We are looking at locking strategies. That will possibly be the 
> next action..
> we do however need to get some of the netatalk team involved..
> (they seem a bit reticent so far)
> 
> julian

---

From: "Michael Rothwell" <[email-masked]>
Date: Sun, 13 Jul 1997 22:17:06 -0400

Or, an even worse scenario: the user wants to delete all files and
directories starting with a dot, so he issues: "rm -r .*", which keeps
going up the directory structure, annihilating everything it can as it
does. (I once did this, a long time ago, on an SGI system while logged in
as root. BOY, was that was ugly).

----------
> From: Michael Stone <[email-masked]>
> Cc: [email-masked]
> Date: Sunday, July 13, 1997 9:28 PM
> 
> Quoting Michael Rothwell ([email-masked]):
> [I said that even if the .AppleDouble directories are hidden,
> they can still cause problems]
> > # rm -r *
> 
> Argh. Ok, scenario 1: User 1 creates directory foo (perm 775)
> , but doesn't use netatalk. User 2 goes into user1's directory 
> with netatalk, umask 022. User 1 decides to get rid of foo. 
> Uh, oh, he can't delete user 2's files from .AppleDouble, so
> the system won't let him remove the directory.
> 
> scenario 2: user1 is a unix newbie, but knows how to create a 
> directory. So, he creates a directory 'bar' from a shell and
> later enters it using netatalk. He gets tired of that directory
> and decides to get rid of it. He does 'cd bar; rm *; cd ..;
> rmdir bar'. user1 then calls for help because the machine 
> won't let him get rid of his directory. It keeps telling
> him the directory is empty, even though 'ls' doesn't show
> any files.
> 
> scenario 3: user1 has gotten into the habit of always using
> 'rm -r', because that's the way to get rid of .AppleDouble.
> So now when he tries to get rid of directory foobar, he does
> 'cd ..; rm -r *'. Oops. user1 then calls for help because all 
> his files are gone.
> 
> I admit these are a bit contrived (though I have seen similar
> situations) but the point is, why create potential problems
> if they can at all be avoided? No, you can't protect users
> (or sysadmins) from everything, but you do the best you can.
> 
> -- 
> Michael Stone, Sysadmin, ITRI
> [email-masked] 
> PGP: finger, or email with "Subject: get pgp key"

---

From: Sak Wathanasin <[email-masked]>
Date: Mon, 14 Jul 1997 11:55:49 +0100

Earlier, I wrote:

...
> 2) you're doing it on a Mac via netatalk in which case the Finder/netatalk
>does
> (1) on your behalf...
...
> (2) certainly works with an arbitary .XXX folder that you can't see on the
> desktop

I take that back with apologies to Micheal: I used the option-empty-trash trick
to try to force the Finder to remove all files. All it did was to suppress the
error message about its not being able to remove some files. It looked as
though it had worked; only when I tried to unmount the volume did I realize
that it hadn't. The AFP command set does have a "delete directory" command, but
says that it must be empty for it to work. One could argue that "empty" means
not counting files that are not visible to the Finder and that netatalk should
do an "rm -rf" for you.

Sak Wathanasin
Network Analysis Limited
178 Wainbody Ave South, Coventry CV3 6BX, UK

Internet: [email-masked]
uucp:     ...!britain.eu.net!nan!sw
Phone: (+44) 1203 419996                    Fax: (+44) 1203 690690